<script lang="ts">
    import type incidentsType from "./../types/incidents"
    import { Remarkable } from 'remarkable'

    const md = new Remarkable()
    export let incidents: incidentsType

    const createDate = (create_at: string) => {
        const date = new Date(create_at)

        return `${`0${date.getDay()}`.slice(-2)}.${`0${date.getMonth()}`.slice(-2)}.${date.getFullYear()} ${`0${date.getHours()}`.slice(-2)}:${`0${date.getMinutes()}`.slice(-2)}`
    }
    const getLabel = (labels: Array<string>) => {
        let label = "danger"

        labels.forEach(entry => entry == "incident" ? null : label = entry)

        switch(label) {
            case "serverity::info":
                return "info"
                break
            case "serverity::success":
                return "success"
                break
            case "serverity::warning":
                return "warning"
                break
            case "serverity::danger":
                return "danger"
                break
        }
    }
</script>

<footer>
    {#each incidents as incident}
        <figure class={getLabel(incident.labels)}>
            <h1>{incident.title}</h1>
                <p>
                    {@html md.render(incident.description)}
                </p>
                <span>
                    {incident.author.name} - {createDate(incident.created_at)}
                </span>
        </figure>
    {/each}
</footer>

<style>
    footer {
        width: 90vw;
        max-width: 1000px;

        display: block;
        margin: 50px auto;
    }

    figure {
        margin: 30px 0px;
        border-radius: 5px;

        background-color: white;

        display: grid;
        grid-template-rows: auto auto auto;
        grid-template-columns: 1fr;
    }

    figure.info {
        border: 0.5px solid var(--blue);
    }
    figure.success {
        border: 0.5px solid var(--green);
    }
    figure.warning {
        border: 0.5px solid var(--yellow);
    }
    figure.danger {
        border: 0.5px solid var(--red);
    }
    figure.info span {
        background-color: var(--blue);
    }
    figure.success span {
        background-color: var(--green);
    }
    figure.warning span {
        background-color: var(--yellow);
    }
    figure.danger span {
        background-color: var(--red);
    }

    h1 {
        margin: 0px;
        padding: 30px 0px 0px 20px;
    }
    p {
        margin: 10px 0px;
        padding: 0px 20px;
    }
    span {
        color: var(--background);

        margin: 10px 0px;
        margin-bottom: 0px;

        padding: 15px 20px;
        border-radius: 0px 0px 5px 5px;
    }
</style>